

local _, Aleri =  ...

Aleri.PrintColour = '|cff00FF96'

print(Aleri.PrintColour..'Aleri - lookup tables loaded')

Aleri.Database = {}

--Aleri.Database.PrintMessage = { SHAMAN = '|cff0070DE', MONK = '|cff00FF96', DEMONHUNTER = '|cffA330C9' }

--Aleri.Database.MemberSlang = {}

Aleri.Database.EquipmentSlots = { 
	{ Id = 1, Name = "Head", Pos = 0 },
	{ Id = 2, Name = "Neck", Pos = 0 }, 
	{ Id = 3, Name = "Shoulder", Pos = 0 }, 
	{ Id = 15, Name = "Back", Pos = 0 }, 
	{ Id = 5, Name = "Chest", Pos = 0 }, 
	{ Id = 9, Name = "Wrist", Pos = 0 }, 
	{ Id = 10, Name = "Hands", Pos = 1 }, 
	{ Id = 6, Name = "Waist", Pos = 1 }, 
	{ Id = 7, Name = "Legs", Pos = 1 }, 
	{ Id = 8, Name = "Feet", Pos = 1 }, 
	{ Id = 11, Name = "Ring 1", Pos = 1 }, 
	{ Id = 12, Name = "Ring 2", Pos = 1 }, 
	{ Id = 13, Name = "Trinket 1", Pos = 1 }, 
	{ Id = 14, Name = "Trinket 2", Pos = 1 }, 
	{ Id = 16, Name = "Main Hand", Pos = 0 }, 
	{ Id = 17, Name = "Off Hand", Pos = 0 },
	{ Id = 18, Name = "Ranged", Pos = 0 }
}

Aleri.Database.InventorySlots = {
	{ Name = 'INVSLOT_HEAD', Id = 1, Pos = 0, Display = 'Head' },
	{ Name = 'INVSLOT_NECK', Id = 2, Pos = 0, Display = 'Neck' },
	{ Name = 'INVSLOT_SHOULDER', Id = 3, Pos = 0, Display = 'Shoulder' },
	{ Name = 'INVSLOT_CHEST', Id = 5, Pos = 0, Display = 'Chest' },
	{ Name = 'INVSLOT_WAIST', Id = 6, Pos = 1, Display = 'Waist' },
	{ Name = 'INVSLOT_LEGS', Id = 7, Pos = 1, Display = 'Legs' },
	{ Name = 'INVSLOT_FEET', Id = 8, Pos = 1, Display = 'Feet' },
	{ Name = 'INVSLOT_WRIST', Id = 9, Pos = 0, Display = 'Wrist' },
	{ Name = 'INVSLOT_HAND', Id = 10, Pos = 1, Display = 'Hand' },
	{ Name = 'INVSLOT_FINGER1', Id = 11, Pos = 1, Display = 'Finger 1' },
	{ Name = 'INVSLOT_FINGER2', Id = 12, Pos = 1, Display = 'Finger 2' },
	{ Name = 'INVSLOT_TRINKET1', Id = 13, Pos = 1, Display = 'Trinket 1' },
	{ Name = 'INVSLOT_TRINKET2', Id = 14, Pos = 1, Display = 'Trinket 2' },
	{ Name = 'INVSLOT_BACK', Id = 15, Pos = 0, Display = 'Back' },
	{ Name = 'INVSLOT_MAINHAND', Id = 16, Pos = 0, Display = 'Main Hand' },
	{ Name = 'INVSLOT_OFFHAND', Id = 17, Pos = 0, Display = 'Off Hand' },
	{ Name = 'INVSLOT_RANGED', Id = 18, Pos = 0, Display = 'Range' },
}

Aleri.Database.Professions = {
	{ Id = 1, Name = 'Alchemy' },
	{ Id = 2, Name = 'Blacksmithing' },
	{ Id = 3, Name = 'Enchanting' },
	{ Id = 4, Name = 'Engineering' },
	{ Id = 5, Name = 'Inscription' },
	{ Id = 6, Name = 'Jewelcrafting' },
	{ Id = 7, Name = 'Leatherworking' },
	{ Id = 8, Name = 'Tailoring' },
	{ Id = 9, Name = 'Herbalism' },
	{ Id = 10, Name = 'Skinning' },
	{ Id = 11, Name = 'Mining' },
}


Aleri.Database.ProfessionIcons = {
	Alchemy = 'Interface\\Icons\\Trade_Alchemy' ,
	Blacksmithing = 'Interface\\Icons\\Trade_Blacksmithing' ,
	Enchanting = 'Interface\\Icons\\Trade_Engraving' ,
	Engineering = 'Interface\\Icons\\Trade_Engineering' ,
	Inscription = 'Interface\\Icons\\INV_Inscription_Tradeskill01' ,
	Jewelcrafting = 'Interface\\Icons\\INV_MISC_GEM_01' ,
	Leatherworking = 'Interface\\Icons\\INV_Misc_ArmorKit_17' ,
	Tailoring = 'Interface\\Icons\\Trade_Tailoring' ,
	Herbalism = 'Interface\\Icons\\INV_Misc_Flower_02' ,
	Skinning = 'Interface\\Icons\\INV_Misc_Pelt_Wolf_01' ,
	Mining = 'Interface\\Icons\\Spell_Fire_FlameBlades' ,
	Cooking = 'Interface\\Icons\\Trade_Cooking' ,
	Fishing = 'Interface\\Icons\\Trade_Fishing' ,
	FirstAid = 'Interface\\Icons\\Spell_Holy_SealOfSacrifice'
}

Aleri.Database.SpecIcons = {
	DRUID = { Balance = 'Interface\\Icons\\Spell_Nature_Starfall', Feral = '', Restoration = 'Interface\\Icons\\Spell_Nature_HealingTouch' },
	DEATHKNIGHT = { Frost = '', Blodd = '', Unholy = ''},
	HUNTER = { BeastMastery = 'Interface\\Icons\\Ability_Hunter_BeastTaming', Marksmanship = '', Survival = ''},
	ROGUE = { Assassination = '', Combat = '', Subtlety = ''},
	MAGE = { Frost = '', Fire = '', Arcane = ''},
	PRIEST = { Holy = '', Discipline = '', Shadow = ''},
	SHAMAN = { Elemental = 'Interface\\Icons\\Spell_Nature_Lightning', Enhancement = 'Interface\\Icons\\Spell_Nature_LightningShield', Restoration = 'Interface\\Icons\\Spell_Nature_MagicImmunity' },
	WARLOCK = { Demonology = '', Affliction = 'Interface\\Icons\\Spell_Shadow_DeathCoil', Destruction = ''},
	WARRIOR = { Arms = '', Fury = '', Protection = ''},
	PALADIN = { Retribution = '', Holy = '', Protection = ''},
}


Aleri.Database.ProfessionCheck = { 'ALCHEMY', 'BLACKSMITHING', 'ENCHANTING', 'ENGINEERING', 'INSCRIPTION', 'JEWELCRAFTING', 'LEATHERWORKING', 'TAILORING', 'HERBALISM', 'SKINNING', 'MINING' }

Aleri.Database.Roles = {
	Tank = { DEATHKNIGHT = 0, WARRIOR = 0, DRUID = 0, PALADIN = 0 },
	Healer = { DRUID = 0, SHAMAN = 0, PRIEST = 0, PALADIN = 0 },
	Ranged = { DRUID = 0, SHAMAN = 0, PRIEST = 0, MAGE = 0, WARLOCK = 0, HUNTER = 0 },
	Melee = { DRUID = 0, SHAMAN = 0, PALADIN = 0, WARRIOR = 0, ROGUE = 0, DEATHKNIGHT = 0 }
}

Aleri.Database.SpecRoleCountFontString = { 
	Tank =  { DEATHKNIGHT = nil, WARRIOR = nil, DRUID = nil, PALADIN = nil },
	Melee =  { DEATHKNIGHT = nil, WARRIOR = nil, DRUID = nil, PALADIN = nil, SHAMAN = nil, ROGUE = nil },
	Healer = { PRIEST = nil, DRUID = nil, SHAMAN = nil, PALADIN = nil },
	Range = { PRIEST = nil, DRUID = nil, SHAMAN = nil, HUNTER = nil, MAGE = nil, WARLOCK = nil }
}

Aleri.Database.SpecDropDownMenu = {
	{ Id = 1, Class = 'DEATHKNIGHT', MenuList = { { Id = 1, Spec = 'Frost', Abbrev = 'frost' }, { Id = 2, Spec = 'Blood', Abbrev = 'blood' }, { Id = 2, Spec = 'Unholy', Abbrev = 'unholy' } } },
	{ Id = 2, Class = 'DRUID', MenuList = { { Id = 1, Spec = 'Boomkin', Abbrev = 'boom' }, { Id = 2, Spec = 'Restoration', Abbrev = 'resto' }, { Id = 3, Spec = 'Cat', Abbrev = 'feral' }, { Id = 4, Spec = 'Bear', Abbrev = 'bear' } } },
	{ ID = 3, Class = 'HUNTER', MenuList = { { Id = 1, Spec = 'Marksmanship', Abbrev = 'mm' }, { Id = 2, Spec = 'Beast Master', Abbrev = 'bm' }, { Id = 2, Spec = 'Survival', Abbrev = 'surv' } } },
	{ ID = 4, Class = 'MAGE', MenuList = { { Id = 1, Spec = 'Fire', Abbrev = 'fire' }, { Id = 2, Spec = 'Frost', Abbrev = 'frost' }, { Id = 2, Spec = 'Arcane', Abbrev = 'arc' } } },
	{ ID = 5, Class = 'PALADIN', MenuList = { { Id = 1, Spec = 'Protection', Abbrev = 'prot' }, { Id = 2, Spec = 'Retribution', Abbrev = 'ret' }, { Id = 2, Spec = 'Holy', Abbrev = 'holy' } } },
	{ ID = 6, Class = 'PRIEST', MenuList = { { Id = 1, Spec = 'Holy', Abbrev = 'holy' }, { Id = 2, Spec = 'Discipline', Abbrev = 'disc' }, { Id = 2, Spec = 'Shadow', Abbrev = 'shad' } } },
	{ ID = 7, Class = 'ROGUE', MenuList = { { Id = 1, Spec = 'Assassination', Abbrev = 'ass' }, { Id = 2, Spec = 'Combat', Abbrev = 'comb' }, { Id = 2, Spec = 'Subtlety', Abbrev = 'subt' } } },
	{ ID = 8, Class = 'SHAMAN', MenuList = { { Id = 1, Spec = 'Elemental', Abbrev = 'ele' }, { Id = 2, Spec = 'Restoration', Abbrev = 'resto' }, { Id = 2, Spec = 'Enhancement', Abbrev = 'enh' } } },
	{ ID = 9, Class = 'WARLOCK', MenuList = { { Id = 1, Spec = 'Affliction', Abbrev = 'aff' }, { Id = 2, Spec = 'Demonology', Abbrev = 'demo' }, { Id = 2, Spec = 'Destruction', Abbrev = 'dest' } } },
	{ ID = 10, Class = 'WARRIOR', MenuList = { { Id = 1, Spec = 'Protection', Abbrev = 'prot' }, { Id = 2, Spec = 'Arms', Abbrev = 'arms' }, { Id = 2, Spec = 'Fury', Abbrev = 'fury' } } },
}

Aleri.Database.ClassCount = {
	{ Class = 'DEATHKNIGHT', Count = 0 },
	{ Class = 'DRUID', Count = 0 },
	{ Class = 'HUNTER', Count = 0 },
	{ Class = 'MAGE', Count = 0 },
	{ Class = 'PALADIN', Count = 0 },
	{ Class = 'PRIEST', Count = 0 },
	{ Class = 'ROGUE', Count = 0 },
	{ Class = 'SHAMAN', Count = 0 },
	{ Class = 'WARLOCK', Count = 0},
	{ Class = 'WARRIOR', Count  = 0 },
	{ Class = 'Total', Count = 0 }
}

Aleri.Database.ClassColours = {
	DEATHKNIGHT = { r = 0.77, g = 0.12, b = 0.23, fs = '|cffC41F3B' },
	DRUID = { r = 1.00, g = 0.49, b = 0.04, fs = '|cffFF7D0A' },
	HUNTER = { r = 0.67, g = 0.83, b = 0.45, fs = '|cffABD473' },
	MAGE = { r = 0.25, g = 0.78, b = 0.92, fs = '|cff40C7EB' },
	PALADIN = { r = 0.96, g = 0.55, b = 0.73, fs = '|cffF58CBA' },
	PRIEST = { r = 1.00, g = 1.00, b = 1.00, fs = '|cffFFFFFF' },
	ROGUE = { r = 1.00, g = 0.96, b = 0.41, fs = '|cffFFF569' },
	SHAMAN = { r = 0.00, g = 0.44, b = 0.87, fs = '|cff0070DE' },
	WARLOCK = { r = 0.53, g = 0.53, b =	0.93, fs = '|cff8787ED' },
	WARRIOR = { r = 0.78, g = 0.61, b = 0.43, fs = '|cffC79C6E' },
	Total = { r = 1, g = 1, b = 1 }
}

Aleri.Database.ClassIDs = { 'DEATHKNIGHT', 'WARRIOR', 'DRUID', 'PALADIN', 'PRIEST', 'SHAMAN', 'HUNTER', 'MAGE', 'ROGUE', 'WARLOCK', 'Total' }

Aleri.Database.SpecToRole = {
	DRUID = { Restoration = 'Healer', Boomkin = 'Ranged', Balance = 'Ranged', Cat = 'Melee',  Bear = 'Tank', unknown = 'Unknown', pvp = 'PvP' },
	SHAMAN = { Elemental = 'Ranged', Enhance = 'Melee', Enhancement = 'Melee', Restoration = 'Healer', unknown = 'Unknown', pvp = 'PvP' },
	HUNTER = { Marksmanship = 'Ranged', BeastMaster = 'Ranged', Survival = 'Ranged', unknown = 'Unknown', pvp = 'PvP' },
	PALADIN = { Holy = 'Healer', Protection = 'Tank', Retribution = 'Melee', unknown = 'Unknown', pvp = 'PvP' },
	WARRIOR = { Arms = 'Melee', Fury = 'Melee', Protection = 'Tank', unknown = 'Unknown', pvp = 'PvP' },
	ROGUE = { Assassination = 'Melee', Combat = 'Melee', Subtlety = 'Melee', unknown = 'Unknown', pvp = 'PvP' },
	PRIEST = { Holy = 'Healer', Discipline = 'Healer', Shadow = 'Ranged', unknown = 'Unknown', pvp = 'PvP' },
	WARLOCK = { Demonology = 'Ranged', Affliction = 'Ranged', Destruction = 'Ranged', unknown = 'Unknown', pvp = 'PvP' },
	MAGE = { Frost = 'Ranged', Fire = 'Ranged', Arcane = 'Ranged', unknown = 'Unknown', pvp = 'PvP' },
	DEATHKNIGHT = { Frost = 'Tank', Blood = 'Tank', Unholy = 'Melee', unknown = 'Unknown', pvp = 'PvP' },
}
















